#!/usr/bin/perl
#!/usr/local/bin/perl
# (c) 2002 Author: Eifert
#     Based on MS-Screener.pl by Simon Pfaffenzeller
#
# MS-Screener.pl
# version: 1.03
# last changed: 1. Mai 2002
# changes:
#   (1-5-02) much rewritten, fixed wrong results (1 hit, but there is nothing)
#
################################################################################

use strict;

################################################################################
#			Variables
################################################################################

my ($begin_search, $tolerance, $mainloopanswer);
my ($totalHits);

# Searchoptions
$begin_search="";
$tolerance="0.1";

################################################################################
# 			write Greetingtext:
################################################################################
$~="ANFANG";
write;


################################################################################
#
#		             Main-Loop
#
################################################################################
do {
#	system ("cls");
	$~="MENU";
	write;
	print "Option: ";
	$mainloopanswer=<STDIN>;
	chomp($mainloopanswer);

	if ($mainloopanswer eq "h") {
		help();
	} elsif ($mainloopanswer eq "c") {
		compare();
	} elsif ($mainloopanswer eq "o") {
		options();
	} elsif ($mainloopanswer ne "e") {
		print "\n*********Please do a valid choice...*************\n";
	}
}until ($mainloopanswer eq "e" || $mainloopanswer eq "q");

exit 0;


########################################################################
#
#	die einzelnen Funktionen
#
########################################################################

sub compare () {
	# local variables
	my ($inputFile, $fileEnding, $file, $fileExt, $fileHits, $res, $outText);
	my (@filesToComp, @defaultMasses, @compareMasses, @result, @fileResults);
	# set start values:
	$totalHits="0";
	$fileExt=1;

	print "Please insert the complete name of the file that is to be compared:\n";
	$inputFile=<STDIN>;
	chomp($inputFile);
	if ($inputFile eq "") {
		print "\n\n*****************No Input.......\n";
		return;
	}

	if (-e $inputFile) {
		if ($inputFile=~/pkm$/ || $inputFile=~/PKM$/) {
			@defaultMasses = readPKM($inputFile);
			$fileEnding = "pkm";
		}else {
			open(INFILE,"$inputFile");
			@defaultMasses =<INFILE>;
			$defaultMasses[0]="";
			close(INFILE);
			$fileEnding = "txt";
		}
	} else {
		print "\n*********The file \"$inputFile\" does not exist!**********\n";
		return;
	}

	opendir(DIR, "c:");
	my @filesToComp = grep { /^$begin_search/  && /$fileEnding$/ && -f "$_" }   readdir(DIR);
	closedir DIR;
	print "The following files will be used\n";
	print "for mass comparison:\n";
	foreach (@filesToComp){
		print $_."\n";
	}

	foreach $file(@filesToComp) {
		if ($file ne $inputFile ) {
			if ($file=~/pkm$/ || $file=~/PKM$/) {
				@compareMasses = readPKM($file);
			}else {
				open (DAS,"$file");
				@compareMasses=<DAS>;
				$compareMasses[0]="";
				close (DAS);
			}
			@result = compareFiles(\@defaultMasses, \@compareMasses);
			$fileHits = $#result+1;
			if ($fileHits > 0 ) {
				$res = "@result";
				push @fileResults, " $fileHits hits in $file\n value(s)=\n $res \n";
			}
		}
	}

	$outText="File: $inputFile\ntotal $totalHits hits\nSearchpattern: '$begin_search'\nTolerance: $tolerance\n@fileResults\n";

	while (-e "ERGEBNIS nr.$fileExt $inputFile.txt") {
		$fileExt++;
	}
	#$ergebnis="\"ERGEBNIS nr.$fileExt $inputFile\"";
	#write ;
	open(ERGEBNIS,">ERGEBNIS nr.$fileExt $inputFile.txt")|| warn "ACHTUNG: Die Datei \"ERGEBNIS nr.$fileExt $inputFile.txt\" kann nicht angelegt werden. $!";
	print ERGEBNIS $outText;
	close (ERGEBNIS);
}

sub compareFiles () {
	# sub variables
	my ($aref, $bref) = @_;
	my (@result);
	my ($mass, $defmass);
	# set some variables
	@result=();

	foreach $mass (@$aref) {	# go through both mass-arrays and
					# compare each value.
		foreach $defmass (@$bref) {
			chomp($mass, $defmass);
			if ($defmass ne "" && $mass ne ""){
				if ($defmass <= $mass+$tolerance && $defmass >= $mass-$tolerance) {
					$totalHits++;
					push @result, "\t$defmass, $mass \n";
				}
			}
		}#neueForeach
	}#vergForeach
	return @result;
}

sub options ()
{
	my ($answer);
	do {
		print "These options influence the search and comparison process.\n\n";
		if ($begin_search eq "") {
			print "Currently, all files with the correct ending are searched.\n";
			print "(e.g. if you search for A_17_Q.pkm, all files with .pkm are searched)\n";
		} else {
			print "Currently, all files which have '$begin_search' at the beginning of the filename\n";
			print "and the correct ending are searched.\n";
			print "(e.g. if you start with A_17_Q.pkm, all files with $begin_search.pkm are searched)\n";
		}
		print "Change: [s]\n\n";
		print "The current masstolerance is: $tolerance \n";
		print "Change: [t]\n\n";

		print "Press [s], [t], or ENTER to quit\n";
		$answer = <STDIN>;
		chomp($answer);

		if ($answer eq "s") {
			print "Search all files which filenames begin with:\n";
			$begin_search = <STDIN>;
			chomp($begin_search);
		} elsif ($answer eq "t") {
			print "Mass tolerance (e.g. 0.1):\n";
			$tolerance = <STDIN>;
			chomp($tolerance);
		}
	} until ($answer eq "" || $answer eq "e");

}

sub help ()
{
	$~="HELP1";
	write; <STDIN>;
	$~="HELP2";
	write; <STDIN>;
}

sub readPKM ()
{
	my ($i, $number_of_peaks, $centerX, $tmp, $peakY, @array_X, @array_Y);
	# Open X,Y - Values from PKM file
	open PKMFile, "<@_[0]" || die;
	$i=0;
	$number_of_peaks=0;
	while(<PKMFile>){
		my $centerX;
		my $tmp;
		my $peakY;
		if(($i>3) && ($i%2==0) && $_ ne "\n") {
			($centerX, $tmp, $peakY) = split (/ /, $_);
			push @array_X, $centerX."\n";
			push @array_Y, $peakY."\n";
			$number_of_peaks++;
		}
		$i++;
	}
	close PKMFile;
	return @array_X;
}


format MENU =
________________________________________________________________________________
| [e]=exit, [c]=compare mass files,					       |
| [o]=options , [h]=help                 				       |
--------------------------------------------------------------------------------
.

format ANFANG =
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  				MS-Screener
  			Wertevergleichsprogramm
  Version: 1.03
  Last change: 1. Mai 2002

  Originally written by Simon Pfaffenzeller.
  Rewritten by Till Eifert.

  Fuer eine Kurzhilfe  bitte "h" eingeben. Eine genauere Beschreibung ist
  der liesmich.doc Datei zu entnehmen.
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

.

format HELP1 =
--------------------------------------------------------------------------------
Das Programm wever.pl muss sich in dem gleichen Ordner wie die zu vergleichenden
Dateien befinden. Die zu vergleichenden Dateien muessen folgende Syntax haben:
BUCHSTABE_NUMMER.txt bzw. BUCHSTABE_NUMMER_NUMMER.txt . Die Nummern koennen
im Bereich zwischen 1 und 1000 liegen, die letztere Nummer kann ein optionales
"M" hinten an stehen haben (Marker). Gross- und Kleinschreibung wird beachtet
("a" ist also nicht gleich "A").
Die Ergebnisse der Berechnungen werden in eigene Dateien mit dem
jeweiligen Namen der verglichenen Datei und dem einleitenden Wort ERGEBNIS nr.
geschrieben. Falls eine Datei mehrmals verglichen werden sollte (etwa mit
verschidenen Toleranzgrenzen), werden die ERGEBNIS Dateien durchnummeriert.
--------------------------------------------------------------------------------
weiter mit ENTER
________________________________________________________________________________
.

format HELP2 =
--------------------------------------------------------------------------------
Um die Werte einer Datei mit den Werten der restlichen Dateien einer
"Buchstabengruppe" zu vergleichen muss ein kleines "v" eingegeben werden. Um
die zu vergleichende "Buchstabengruppe" oder den Toleranzwert fuer das maching
zu veraendern muss ein kleines "a" eingegeben werden.
Um die Werte einer neuen Datei einzugeben wird ein kleines "s" eingegeben. In
die erste Zeile wird der Name der Datei geschrieben, in die naechste Zeile der
erste Wert. In jinputFileer Zeile darf ein Wert stehen. Nach Eingabe des letzten
Wertes wird die ENTER Taste betaetigt und dann die Tastenkombination Strg+z
eingegeben, um die Eingabe zu beenden.
Um sich die Werte einer Datei anzugucken, oeffnet man diese Datei am besten in
einem eigenen Fenster.
--------------------------------------------------------------------------------
weiter mit ENTER
________________________________________________________________________________
.
